Search Unity

  1. Good news ✨ We have more Unite Now videos available for you to watch on-demand! Come check them out and ask our experts any questions!
    Dismiss Notice
  2. Ever participated in one our Game Jams? Want pointers on your project? Our Evangelists will be available on Friday to give feedback. Come share your games with us!
    Dismiss Notice

Non-PIE Binary apple send this email to me

Discussion in 'iOS and tvOS' started by ken090505, May 9, 2013.

  1. ken090505

    ken090505

    Joined:
    May 7, 2013
    Posts:
    1
    Yesterday i upload my application update to apple for review.

    But apple send the update for my application to me, it say

    Non-PIE Binary - The executable "My APP NAME" is not a Position Independent Executable. Please ensure that your build settings are configured to create PIE executables.

    i already tried to use both option "Yes/No" and re-submit to apple for review.
    but it keep send Non-PIE Binary update email to me

    is my xcode setting or my unity project problems?

    thanks
     
  2. Mantas-Puida

    Mantas-Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Posts:
    1,857
    This reply is just a warning, you do NOT need to resubmit your application.

    P.S. we are looking for solution.
     
  3. capyvara

    capyvara

    Joined:
    Mar 11, 2010
    Posts:
    78
    Same thing happened to me, saw a post at Xamarim related to the same stuff, so it may be something in mono Apple wasn't checking before.
     
  4. NeedNap

    NeedNap

    Joined:
    Nov 1, 2012
    Posts:
    22
    I have the same problem!

    Are you sure that the Apple Review Team will not reject the app?
    I need to put the app online as soon as possible!
     
  5. NeedNap

    NeedNap

    Joined:
    Nov 1, 2012
    Posts:
    22
    I confirm that Apple Review Team approved my app also with this warning message!
     
  6. JonnyHilly

    JonnyHilly

    Joined:
    Sep 4, 2009
    Posts:
    741
    I am guessing that even if you have the right build settings, that if a plugin lib was built without the PIE settings, there is no way you can fix it. ...apart from removing plugins or asking all the plugin manufacturers to make sure they are PIE compliant.
    It could also depend on the target you are building to.... probably 5.0 or newer results in this error... it might not if you build to old OS target, but thats just a guess.
     
  7. VicM

    VicM

    Joined:
    Mar 14, 2012
    Posts:
    22
    I also confirm that today my app (update) has been approved even when I received the message.
    Non-PIE Binary - The executable 'KeplerAR.app' is not a Position Independent Executable. Please ensure that your build settings are configured to create PIE executables.
     
    Last edited: May 20, 2013
  8. OceanBlue

    OceanBlue

    Joined:
    May 2, 2013
    Posts:
    251
    It'd be nice if someone were able to figure out what this Non-PIE binary thing is and how to fix it.
     
  9. arkon

    arkon

    Joined:
    Jun 27, 2011
    Posts:
    1,099
    I too just got the same warning, I'm using 3.5.7 which worked fine 4 weeks ago. Must be something new Apple are now detecting. Mantas when you find the problem will you be fixing it for us using 3.5.7?
     
  10. JonnyHilly

    JonnyHilly

    Joined:
    Sep 4, 2009
    Posts:
    741
    I am on 4, still gets the warning even with the correct build settings, so might be the plugins/libs built before the new Apple rule.
    I just submitted my app a couple of days ago, so waiting to see if it passes or gets rejected.... will update here when I find out
     
  11. PixelEnvision

    PixelEnvision

    Joined:
    Feb 7, 2012
    Posts:
    495
    I haven't tried that yet but here it some piece of info that might help =>"Xcode will only make PIE binaries if deployment target is iOS >= 4.3"

    So I think if you enable PIE binary setting in xcode project AND make sure target is 4.3 it might work...

    If you can try that before I do, please post the result back here ...
     
  12. JonnyHilly

    JonnyHilly

    Joined:
    Sep 4, 2009
    Posts:
    741
    yep, my build targets were always 4.3 before this. for my latest build submission its built to 5.0. But still got the same apple warning
     
  13. JonnyHilly

    JonnyHilly

    Joined:
    Sep 4, 2009
    Posts:
    741
    confirmed what Mantas and NeedCap said. My app just got approved by apple, regardless of the warning.
     
  14. Majicpanda

    Majicpanda

    Joined:
    Dec 23, 2012
    Posts:
    12
    There any update to this?
     
  15. monkeyThunk

    monkeyThunk

    Joined:
    Oct 6, 2011
    Posts:
    13
    I got the same warning email today as well. Sounds like I don't need to worry about it, but it would feel better to get no warnings after submitting!
     
  16. Mantas-Puida

    Mantas-Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Posts:
    1,857
    Update: fix is on its way towards testers
     
  17. tonio96

    tonio96

    Joined:
    Jun 10, 2013
    Posts:
    1
    Thanks Mantas. I work on unity 3.5.7 version. Could you tell us on which version this fix will be applied ? Will it be applied only on unity4 ?
     
  18. Mantas-Puida

    Mantas-Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Posts:
    1,857
    Unity 3.5 is not affected by this issue.
     
  19. Bogdan

    Bogdan

    Joined:
    Jun 17, 2013
    Posts:
    1
    Hi,

    My application has the same problem, but it got approved by Apple. The problem seems to be caused by Unity (4.1.5). If inside your Asset folder you have a "Plugins" folder the dll file auto-generated by Unity (Assembly-CSharp.dll) it cannot be configured to Non-PIE Binary. (you can experiment that by just creating an empty project with a "Plugins" folder inside "Assets").
     
  20. radazen

    radazen

    Joined:
    Feb 29, 2012
    Posts:
    13
    In what way is Unity 3.5 "not affected" by the issue? I'm using Unity 3.5.7 and received the same warning email, as have several other Unity 3.5 users in this thread.
     
  21. andymads

    andymads

    Joined:
    Jun 16, 2011
    Posts:
    1,495
    Yeah, we use 3.5.7 and have had this warning email a couple of times now.
     
  22. Mantas-Puida

    Mantas-Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Posts:
    1,857
    Hmm.. I can't reproduce it locally with project made with Unity 3.5.7. Could you please submit a bug report with your Xcode project attached to it and ping me via PM with your case number.
    Thanks!
     
  23. Mantas-Puida

    Mantas-Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Posts:
    1,857
    We got one case with 3.5.7 project, but it had Deployment Target set to iOS 4.0, which was the actual reason why non-PIE binary was produced. Changing it to iOS 4.3 fixed the problem. If anybody still gets non-PIE submission warning with 3.5.7, using latest stable Xcode and Deployment Target set to >= 4.3 please ping me with repro case.
    Thanks!
     
  24. arkon

    arkon

    Joined:
    Jun 27, 2011
    Posts:
    1,099
    Well that explains why I get them then as I always target 4.2 IOS.
     
  25. Maybe_memory

    Maybe_memory

    Joined:
    Sep 15, 2012
    Posts:
    8
    We got the same case. We use unity 4.0.
    Did this warning cause by unity? Did this problem fix in the newest version?
     
  26. Mantas-Puida

    Mantas-Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Posts:
    1,857
    Fix is coming with Unity 4.2.
     
  27. triton60

    triton60

    Joined:
    Aug 13, 2012
    Posts:
    2
    I am seeing the error in Unity 4.3.

    Is there an eta for this being fixed?

    Thanks,

    Andrew.
     
  28. Mantas-Puida

    Mantas-Puida

    Unity Technologies

    Joined:
    Nov 13, 2008
    Posts:
    1,857
    It was fixed for 4.2, but accidentally came back with 4.3. It is scheduled to be fixed again with 4.3.1.
     
  29. triton60

    triton60

    Joined:
    Aug 13, 2012
    Posts:
    2
    Thanks Mantas,

    Andrew.
     
unityunity